<?php
/*
Plugin Name: WP Slimbox Reloaded
Plugin URI: http://academic.lozbo.org/projects/wp-slimbox-reloaded/
Original Script URI: http://www.digitalia.be/software/slimbox
Description: This plugin is based on Slimbox (developed by Christophe Beyls), a 4kb visual clone of the popular Lightbox JS v2.0 (developed by Lokesh Dhakar), written using the Mootools javascript framework. It was designed to be small, efficient, more convenient and 100% compatible with the original Lightbox v2. I made a modification of the <a href="http://code.google.com/p/slimbox-wp/" title="Original Slimbox Plugin">original Slimbox WP by Jorge Serra</a> and a great deal of copying/adjusting the already coded <a href="http://zeo.unic.net.my/notes/lightbox2-for-wordpress/" title="Original Lightbox 2 Plugin">WP Lightbox 2 plugin by Safirul Alredha</a>. This plugin was developed with all the aforementioned help by Lozbo with MooTools 1.2, Slimbox 1.64 and WordPress 2.6.
Version: .5
Author: lozbo.org
*/

//////////////////////////////////////////////////////////////////////////////////// edit here! 


// do you want this plugin to automatically add rel="lightbox[post-#]" to your posts? Default is 'yes'
$automatically_add_code = 'yes';

// do you already have a running mootools 1.2 js on your Wordpress or template? Default is 'no'
$already_has_mootools = 'yes';

// supported images
define("IMAGE_FILETYPE", "(jpg|jpeg|png|gif|bmp|ico)", true);


//////////////////////////////////////////////////////////////////////////// do not edit below!

function wp_slimboxreloaded_init() {
	$url = get_bloginfo('wpurl');

?>

<!-- wp-slimbox-reloaded plugin by Lozbo -->

<?php 
/*

If you already have mootools somewhere in your code (template or plugin), 
we should not write an additional call, but if you don't, it's called right from here.

Please Note this plugin could be problematic with additional or outdated versions of mootools, 
I'm using mootools 1.2 here, more on http://mootools.net/

Also, your template *must* have wp_head() *below* the first declaration of mootools
(For example: right before the end of the closing (X)HTML head element).

*/
global $already_has_mootools;
if ($already_has_mootools == 'no' ) { 
?>
<script type="text/javascript" src="<?php bloginfo('template_url'); ?>/src/mootools.js"></script>
<?php 	
// if you already have mootools, print nothing 
} else { echo ''; } ?>
<script type="text/javascript" src="<?php echo $url; ?>/wp-content/plugins/wp-slimbox-reloaded/js/slimbox.js"></script>
<link rel="stylesheet" href="<?php echo $url; ?>/wp-content/plugins/wp-slimbox-reloaded/css/slimbox.css" type="text/css" media="screen" />

<style type="text/css" media="screen">
	#prevLink, #nextLink { background: transparent url("<?php echo $url; ?>/wp-content/plugins/wp-slimbox-reloaded/css/blank.gif") no-repeat; }
	#prevLink:hover, #prevLink:visited:hover { background: url("<?php echo $url; ?>/wp-content/plugins/wp-slimbox-reloaded/css/prevlabel.gif") left 15% no-repeat; }
	#nextLink:hover, #nextLink:visited:hover { background: url("<?php echo $url; ?>/wp-content/plugins/wp-slimbox-reloaded/css/nextlabel.gif") right 15% no-repeat; }
</style>

<script type="text/javascript">
	var fileLoadingImage = "<?php echo $url; ?>/wp-content/plugins/wp-slimbox-reloaded/css/loading.gif";
	var fileBottomNavCloseImage = "<?php echo $url; ?>/wp-content/plugins/wp-slimbox-reloaded/css/closelabel.gif";
</script>

<!-- end wp-slimbox-reloaded plugin by Lozbo -->

<?php }

add_action('wp_head', 'wp_slimboxreloaded_init');


// automatically add rel="lightbox[post-#]" to your linked images! 
// great isn't it? You can turn this off above

global $automatically_add_code;
if ($automatically_add_code == 'yes' ) { 

function wp_slimboxreloaded_replace($string) {
	global $post;
	$pattern = '/(<a(.*?)href="([^"]*.)'.IMAGE_FILETYPE.'"(.*?)><img)/ie';
  	$replacement = 'stripslashes(strstr("\2\5","rel=") ? "\1" : "<a\2href=\"\3\4\"\5 rel=\"lightbox[post-'.$post->ID.']\" ><img")';
	return preg_replace($pattern, $replacement, $string);
}

add_filter('the_content', 'wp_slimboxreloaded_replace');

}


// add a quicktag  when writing a post or a page and using the html editor
// (for writing code: not shown in the visual editor) 

function wp_slimboxreloaded_add_quicktag() {
	if (strpos($_SERVER['REQUEST_URI'], 'post.php') || strpos($_SERVER['REQUEST_URI'], 'post-new.php') || strpos($_SERVER['REQUEST_URI'], 'page-new.php') || strpos($_SERVER['REQUEST_URI'], 'page.php')) {
?>
<script type="text/javascript">//<![CDATA[
	var toolbar = document.getElementById("ed_toolbar");
<?php
	edit_insert_button("slimbox", "wp_slimboxreloaded_handler", "Slimbox with Caption");
?>
	var state_my_button = true;

function wp_slimboxreloaded_handler() {
	if (state_my_button) {
		var myURL = prompt('Enter the original image URL (required)', 'http://');
		var myCaption = prompt('Enter image caption (title attribute)');
		var myIMG = prompt('Enter the Image thumbnail (required)', 'http://');
		var myWidth = prompt('Enter Width of image thumbnail (required)');
		var myHeight = prompt('Enter Height of image thumbnail (required)');
		var myAlt = prompt('Enter a description of the image');
		var mySet = prompt('Insert group name for image set (optional)', '[groupname]');
		if (myURL && myIMG && myWidth && myHeight) {
			myValue = '<a href="'+myURL+'" rel="lightbox'+mySet+'" title="'+myCaption+'"><img src="'+myIMG+'" width="'+myWidth+'" height="'+myHeight+'" alt="'+myAlt+'" /></a>';
			edInsertContent(edCanvas, myValue); 
		}
	}
}
//]]></script>

<?php } }

if (!function_exists('edit_insert_button')) {
	//edit_insert_button: Inserts a button into the editor
	function edit_insert_button($caption, $js_onclick, $title = '')	{
	?>
	if (toolbar) {
		var theButton = document.createElement('input');
		theButton.type = 'button';
		theButton.value = '<?php echo $caption; ?>';
		theButton.onclick = <?php echo $js_onclick; ?>;
		theButton.className = 'ed_button';
		theButton.title = "<?php echo $title; ?>";
		theButton.id = "<?php echo "ed_{$caption}"; ?>";
		toolbar.appendChild(theButton);
	}
	
<?php } }

add_filter('admin_footer', 'wp_slimboxreloaded_add_quicktag');

?>